#include <stdio.h>
#include <sys/time.h>
#include <unistd.h>
#include "dumH.h" // obtain the generated stub 
#include "DummySoapBinding.nsmap" // obtain the generated XML namespace mapping table for the Quote service 
void printobj(struct ns1__ComplexObject* co);
void uvolni(struct soap *soap,struct ns1__ComplexObject* co);

long long currentTimeMillis() {
 struct timeval t1;
 long long ms;
 gettimeofday(&t1,NULL);
 ms = ((long long)t1.tv_sec)*1000 + t1.tv_usec/1000;
 return ms;
}

main() {  
   int rozcvicka = 50;
   int pocet = 2000;
   double rychlost;
   int i,j;
   long long start;
   long long end;
   long doba;
   struct soap *soap = soap_new();
   struct ns1__getSimpleResponse *out;
   struct ns1__getComplexResponse *out2;
   struct ns1__ComplexObject *strom1,*strom2;

   out = malloc(sizeof(struct ns1__getSimpleResponse));
   out2 = malloc(sizeof(struct ns1__getComplexResponse));

   //ziskat prvni
   if(soap_call_ns1__getSimple(soap, "http://localhost:8080/axis/services/Dummy", "", out) == SOAP_OK) {
	   strom1 = out->getSimpleReturn;
	   printobj(strom1);
	   printf("co.info.OS=%s\n",strom1->info->OS);
	   printf("co.info.VM=%s\n",strom1->info->VM);
   } else {// an error occurred 
      soap_print_fault(soap, stderr); // display the SOAP fault on the stderr stream 
      exit(1);
   }
   
  printf("gSOAP 2.5\n");
  printf("calls;speed (calls/sec)\n");

  for(i=0;i<rozcvicka;i++) {
      start = currentTimeMillis();
      for(j=0;j<pocet;j++) {
          if(soap_call_ns1__getComplex(soap, "http://localhost:8080/axis/services/Dummy", "",  strom1, out2) != SOAP_OK) {
              soap_print_fault(soap, stderr); // display the SOAP fault on the stderr stream 
              exit(1);
          }
          strom2 = out2->_getComplexReturn;
          uvolni(soap,strom1);
          strom1 = strom2;
       }
       end = currentTimeMillis();
       doba = (end-start);
       rychlost = pocet;
       rychlost *= 1000;
       rychlost /= doba;
       printf("%lld; %.0f\n",strom2->count,rychlost);
  }


}

void uvolni(struct soap *soap,struct ns1__ComplexObject* co) {
	   soap_dealloc(soap,co);

}
void printobj(struct ns1__ComplexObject* co) {
   int i,arraysize;
	   printf("--------------------------------------\n");
	   printf("co.count=%ld\n",co->count);
           arraysize = co->array->__size;
	   printf("co.array.size=%d\n",arraysize);
	   for(i=0;i<arraysize;i++) {
	       printf("co.array[%d]=%s\n",i,co->array->__ptr[i]);
	   }
	   printf("co.info.OS=%s\n",co->info->OS);
	   printf("co.info.VM=%s\n",co->info->VM);
	   printf("co.info.mem=%s\n",co->info->mem);
	   printf("co.info.rt=%s\n",co->info->rt);
	   printf("co.sub1=%p\n",co->sub1);
	   printf("co.sub1.a=%s\n",co->sub1->a);
	   printf("co.sub1.b=%s\n",co->sub1->b);
	   printf("co.sub1.c=%s\n",co->sub1->c);
	   printf("co.sub1.child=%p\n",co->sub1->child);
	   printf("co.sub2=%p\n",co->sub2);
	   printf("co.sub2.a=%s\n",co->sub2->a);
	   printf("co.sub2.b=%s\n",co->sub2->b);
	   printf("co.sub2.c=%s\n",co->sub2->c);
	   printf("co.sub2.child=%p\n",co->sub2->child);
}
